#Alexandra Marrero
#11/6/10
#Assignment 11

import time
import time, random
import sys

def BFS(graph,goal):
        current=graph.initial_state
        to_explore=expand(current)
        while to_explore:
            if current==goal:
                break
            current=to_explore[0]
            to_explore=to_explore+expand(current)

def linebreak(text, col=72):
        retval=""
        count=0
        for c in text:
            if count>col and c==" ":
                retval+="\n"
                count=0
            else:
                retval+=c
                count+=1
        return retval

class State:
    def __init__(self, name, description):
        self.name = name
        self.description = description
        self.edges = []
        self.objects = []


class Edge:
    def __init__(self, name, from_node, commands, to_node, description):
        self.name = name
        self.from_node = from_node 
        self.commands = commands
        self.to_node = to_node
        self.description = description
                

class Objects:
    def __init__(self, node_name, unique_name, short_desc, desc, weight):
        self.node_name = node_name
        self.unique_name = unique_name
        self.short_desc = short_desc
        self.desc = desc
        self.weight = weight
        

class Health:
    def __init__(self, health):
        self.health = health
        
class Engine:
    def __init__(self, filename, counter=None):
        self.filename = filename
        self.counter = counter
        self.initial_state = None
        self.state = None
        self.objects = None
        self.constraints = None

    def load(self):
        self.states = {}
        edges = []
        constraints = []
        self.initial_time = time.clock()
        fp = open(self.filename)
        for line in fp:
            if len(line) == 0 or line[0] == '#':
                continue
            items = line.strip().split("::")
            if items[0] == 'node':
                s = State(*items[1:])
                if self.initial_state is None:
                    self.initial_state = s
                self.states[items[1]] = s
            elif items[0] == 'edge':
                edges.append(Edge(*items[1:]))
            elif items[0] == 'object':
                o = Objects(*items[1:])
                self.states[o.node_name].objects.append(o)
        for edge in edges:
            self.states[edge.from_node].edges.append(edge)


##    def BFS(graph,goal):
##        current=graph.initial_state
##        to_explore=expand(current)
##        while to_explore:
##            if current==goal:
##                break
##            current=to_explore[0]
##            to_explore=to_explore+expand(current)
            

    def play(self):
        current_state = self.initial_state
        counter = 0
        backpack = []
        while True:
            lb=linebreak(current_state.description)
            print(lb)
            command = input("Command> ")
            for edge in current_state.edges:
                if command in edge.commands:
                    current_state = self.states[edge.to_node]
                    counter = counter+1
                    break
            CS=command.split()
            if CS[0]=="pickup":
                print(CS)
                for objects in current_state.objects:
                    if CS[1]==objects.unique_name:
                        current_state.objects.remove(objects)
                        backpack.append(objects)
                        print("The object is now in your backpack!")
            if CS[0]=="check":
                print("Here's what's in your backpack:")
                for objects in backpack:
                    print(objects.unique_name)
            if CS[0]=="lookat":
                if CS[1]==objects.unique_name:
                    print(objects.desc)
            if CS[0]=="drop":
                print(CS)
                for objects in backpack:
                    if CS[1]==objects.unique_name:
                        backpack.remove(objects)
                        current_state.objects.append(objects)
                        print ("The object is now in whatever place this is.")
            if CS[0]=="look":
                print("The objects, if any, in this node are:")
                for objects in current_state.objects:
                    print(objects.unique_name)
            if CS[0]=="hit":
                print("Hey, that was just rude! Be careful who you do that to, or something bad could happen!")
            if CS[0]=="hitbandit":
                print("Ooooh boy, now you've done it! Looks like it's game over for you now!")
                print("GAME OVER.")
                sys.exit()
#Over here would have been the 'help' function, which I still could not get to work, mostly since the Breadth First Search code we got apparently involves other functions I do not have. It is something to expand upon later, though.
            if CS[0]=="help":
                print("Fine, you nitwit. Since you can't figure it out on your own, try this:")
                if CS[1]==current_state.name:
                    destination = self.initial_state.name
                    print(BFS(self, destination))
            if CS[0]=="goaway":
                print("Sorry to hear that. Maybe I won't be so mean to you next time. 'Till then, au revoir!")
                print("GAME OVER.")
                sys.exit()


game = Engine("interactiveFictionGame_AlexMarrero.txt")
game.load()
game.play()
